*This script contains calculations for Table 1, t-test mentioned on page 5, and structural deficit to GDP ratios in 2020-2021 referenced on page 5
ssc install outreg2
ssc install estout
ssc install coefplot
 
clear
cd ".\Figures_and_Calcs_Section_2_1"

clear
import excel WEOApr2022all.xlsx ,  firstrow case(lower)
browse

keep weocountrycode weosubjectcode country subjectdescriptor units scale estimatesstartafter j k l m n o p q r s t u v w x y z aa ab ac ad ae af ag ah ai aj ak al am an ao ap aq ar as at au av aw ax ay az

order weocountrycode country weosubjectcode subjectdescriptor estimatesstartafter z aa ab ac ad ae af ag ah ai aj ak al am an ao ap aq ar as at au av aw ax ay az  units scale  
rename z stat_1996
rename	aa	stat_1997
rename	ab	stat_1998
rename	ac	stat_1999
rename	ad	stat_2000
rename	ae	stat_2001
rename	af	stat_2002
rename	ag	stat_2003
rename	ah	stat_2004
rename	ai	stat_2005
rename	aj	stat_2006
rename	ak	stat_2007
rename	al	stat_2008
rename	am	stat_2009
rename	an	stat_2010
rename	ao	stat_2011
rename	ap	stat_2012
rename	aq	stat_2013
rename	ar	stat_2014
rename	as	stat_2015
rename	at	stat_2016
rename	au	stat_2017
rename	av	stat_2018
rename	aw	stat_2019
rename	ax	stat_2020
rename	ay	stat_2021
rename	az	stat_2022

 
keep weocountrycode country weosubjectcode estimatesstartafter stat_1996 stat_1997 stat_1998 stat_1999 stat_2000 stat_2001 stat_2002 stat_2003 stat_2004 stat_2005 stat_2006 stat_2007 stat_2008 stat_2009 stat_2010 stat_2011 stat_2012 stat_2013 stat_2014 stat_2015 stat_2016 stat_2017 stat_2018 stat_2019 stat_2020 stat_2021  stat_2022
drop if country==""
reshape long stat_  , i(country weosubjectcode estimatesstartafter) j(year)  
 reshape wide stat_, i(country year estimatesstartafter) j(weosubjectcode) string

keep weocountrycode country  year estimatesstartafter stat_GGXWDG_NGDP stat_GGSB_NPGDP stat_GGXCNL_NGDP stat_GGXONLB_NGDP stat_NGDP_RPCH stat_NGDPRPC stat_PCPIPCH
replace stat_NGDP_RPCH="." if stat_NGDP_RPCH=="--"
destring stat_NGDP_RPCH, generate(NGDP_RPCH_clean) ignore("N/A" "n/a" )
drop  stat_NGDP_RPCH

destring stat_PCPIPCH, generate(PCPIPCH_clean) ignore("N/A" "n/a" )
drop  stat_PCPIPCH

 
replace stat_NGDPRPC="." if stat_NGDPRPC=="--"
destring stat_NGDPRPC, generate(NGDPRPC_clean) ignore("N/A" "n/a" )
drop  stat_NGDPRPC


bysort country year: egen perc_change_GDP_WEO_lag=max(NGDP_RPCH_clean)
bysort country year: egen perc_change_GDP_percap_WEO_lag=max(NGDPRPC_clean)
bysort country year: egen inflation=max(PCPIPCH_clean)


drop if stat_GGXWDG_NGDP==""|stat_GGXWDG_NGDP=="n/a" |stat_GGXCNL_NGDP==""|stat_GGXCNL_NGDP=="n/a" |stat_GGXONLB_NGDP==""|stat_GGXONLB_NGDP=="n/a"|stat_GGSB_NPGDP=="n/a"
drop if year<2000
 rename	stat_GGXWDG_NGDP	GGXWDG_NGDP
 rename	stat_GGXCNL_NGDP	GGXCNL_NGDP
 rename	stat_GGXONLB_NGDP	GGXONLB_NGDP
 rename	stat_GGSB_NPGDP	    GGSB_NPGDP
 
 drop      NGDP_RPCH
 


destring GGSB_NPGDP, generate(GGSB_NPGDP_clean) ignore("N/A" "n/a")
drop  GGSB_NPGDP
rename GGSB_NPGDP_clean structural_balance_WEO_lag
 
destring GGXWDG_NGDP, generate(GGXWDG_NGDP_clean) ignore("N/A" "n/a" "--")
drop  GGXWDG_NGDP
rename GGXWDG_NGDP_clean gross_debt_WEO_lag

destring GGXCNL_NGDP, generate(GGXCNL_NGDP_clean) ignore("N/A" "n/a")
drop  GGXCNL_NGDP
rename GGXCNL_NGDP_clean budget_balance_WEO_lag

replace GGXONLB_NGDP ="." if GGXONLB_NGDP=="--"
destring GGXONLB_NGDP, generate(GGXONLB_NGDP_clean) ignore("N/A" "n/a")
tab GGXONLB_NGDP
drop  GGXONLB_NGDP
rename GGXONLB_NGDP_clean primary_budget_balance_WEO_lag



gen estimate=0
replace estimate=1 if year>estimatesstartafter
drop estimatesstartafter 
drop weocountrycode

 
  
keep country  year budget_balance_WEO_lag primary_budget_balance_WEO_lag structural_balance_WEO_lag gross_debt_WEO_lag perc_change_GDP_WEO_lag perc_change_GDP_percap_WEO_lag inflation

sort country year 
bysort country: gen lag_GDP_per_cap=perc_change_GDP_percap_WEO_lag[_n-1]
gen perc_change_GDP_per_cap_WEO_lag=100*(log(perc_change_GDP_percap_WEO_lag)-log(lag_GDP_per_cap))
drop perc_change_GDP_percap_WEO_lag


rename budget_balance_WEO_lag budget_balance_WEO
rename primary_budget_balance_WEO_lag primary_budget_balance_WEO
rename gross_debt_WEO_lag gross_debt_WEO
rename perc_change_GDP_WEO_lag perc_change_GDP_WEO
rename perc_change_GDP_per_cap_WEO_lag perc_change_GDP_per_cap_WEO
order country year  budget_balance_WEO primary_budget_balance_WEO structural_balance_WEO_lag
  
 save WEO_data_base, replace 
  
 *Create Lookup With History of Fiscal Rules
   clear
 insheet using "Fiscal_Rules_All_Countries_Flagged_0609_2022.csv",names
replace countryname="Guinea-Bissau" if countryname=="Guinea Bissau"
replace countryname="Islamic Republic of Iran" if countryname=="Iran"
replace countryname="Montenegro" if countryname=="Montenegro, Rep. of"
replace countryname="Republic of Congo" if countryname=="Congo, Republic of"
replace countryname="The Bahamas" if countryname=="Bahamas, The"
drop country
rename countryname country

replace erexpenditurerule ="0" if erexpenditurerule =="-"
replace rrrevenuerule ="0" if rrrevenuerule =="-"
replace bbrbudgetbalancerule ="0" if bbrbudgetbalancerule =="-"
replace drdebtrule ="0" if drdebtrule =="-"
***
replace escapeclauseorsuspension=1 if escapeclauseorsuspension>=1
gen fiscal_rule_any=0
replace fiscal_rule_any=1 if erexpenditurerule =="1"|rrrevenuerule =="1"|bbrbudgetbalancerule =="1"|drdebtrule =="1"
destring erexpenditurerule, generate(erexpenditurerule_clean) ignore("N/A" "..")
destring rrrevenuerule, generate(rrrevenuerule_clean) ignore("N/A" "..")
destring bbrbudgetbalancerule, generate(bbrbudgetbalancerule_clean) ignore("N/A" "..")
destring drdebtrule, generate(drdebtrule_clean) ignore("N/A" "..")
drop erexpenditurerule
drop rrrevenuerule
drop bbrbudgetbalancerule
drop drdebtrule
rename erexpenditurerule_clean erexpenditurerule
rename rrrevenuerule_clean rrrevenuerule
rename bbrbudgetbalancerule_clean bbrbudgetbalancerule
rename drdebtrule_clean drdebtrule
keep year country fiscal_rule_any 
save LU_Fiscal_Rules_for_Join, replace 

keep if year==2021
replace year=2022
append using LU_Fiscal_Rules_for_Join
save LU_Fiscal_Rules_Thru_2022_for_Join, replace 

*Create LU table with Income and Geography Classifications
clear
import excel LU_Income_Geography_Classification.xlsx ,  firstrow case(lower)
browse
drop country_world_bank
save LU_Income_Geography_Classification, replace

**Join onto WEO Base
use WEO_data_base, replace
rename structural_balance_WEO_lag structural_balance_WEO
merge 1:1 country year using LU_Fiscal_Rules_Thru_2022_for_Join
drop if _merge==2
replace fiscal_rule_any=0 if fiscal_rule_any==.
drop _merge
save WEO_data_with_fiscal_rules, replace

use WEO_data_with_fiscal_rules, replace
keep if structural_balance_WEO!=.
keep if year>=2007 & year<=2021
merge m:1 country using LU_Income_Geography_Classification
drop if _merge==2
drop _*
drop if incomegroup=="High income"
collapse(mean) mean_structural_balance=structural_balance_WEO, by(fiscal_rule_any year)
save Structural_Balance_by_Year_Fiscal_Rule, replace

**Reference (Page 5): "The two years that stand out, however, are 2020 and 2021, as in these two years the
** trend reverses as countries with fiscal rules have slightly larger structural deficit-to-GDP ratios (4.59%), on
** average, than those without (4.35%)."
use Structural_Balance_by_Year_Fiscal_Rule, replace
keep if year>2019
collapse   (mean) mean_structural_balance=mean_structural_balance , by(fiscal_rule_any  )
gen category="Countries Without Fiscal Rule"
replace category="Countries With Fiscal Rule" if fiscal_rule_any==1

**Reference (Page 5): "Table 1 shows that during the 15-year period spanning 2007-2021, the average structural deficitto-GDP ** ratio of countries adhering to any type of fiscal rule was 0.63 percentage points lower than the structural
** deficit of countries without a fiscal rule, and a one-sided t-test for the difference in means shows this difference
** to be statistically significant"  (Note: One-sided test, Ha: mean(0) - mean(1) < 0)
use Structural_Balance_by_Year_Fiscal_Rule, replace
ttest mean_structural_balance, by(fiscal_rule_any)


**Output: Table 1
use Structural_Balance_by_Year_Fiscal_Rule, replace
collapse   (mean) mean_structural_balance=mean_structural_balance (sd) sd_structural_balance= mean_structural_balance , by(fiscal_rule_any  )
gen category="Countries Without Fiscal Rule"
replace category="Countries With Fiscal Rule" if fiscal_rule_any==1
rename mean_structural_balance Average
rename sd_structural_balance Standard_Deviation
order category
drop fiscal_rule_any
sort category
cd ".."
export delimited using "Output\Table 1.csv",   replace
