cd ".\Files for Reproduction - Fiscal Rule Index\"

clear
 insheet using "IMF Fiscal Rule Dataset - Base for Index.csv",names
drop if year==.
save base_fiscal_rule_index_analysis_table, replace

clear
 insheet using "IMF Fiscal Council Dataset - Base for Index.csv",names
 drop v*
drop if year==.
drop if year==1945
drop if year==1989
tab country
save base_fiscal_council_index_analysis_table, replace


**Two things:
*1) Incorporate coverage in fiscal council dataset for the two scores this gives use
*2) Calculate supranational scores, with necessary exclusions (no fiscal councils, for example I think? Not sure)
*3) Combine all scores
******************************************
**All National Rules First
******************************************
**1) BBR, National
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.


keep if bbr_rule_in_place==1
keep year country bbr* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if bbr_supranational==1
keep if year>1996

**Legal basis
tab bbr_national_legal_basis
**Ranges from 0-5, rescale from 0-1
gen bbr_national_legal_rescaled=bbr_national_legal_basis/5

**Monitoring mechanism outside the government 
tab bbr_national_monitoring

**Independent body setting budget assumptions and monitoring budget implementation 
tab independent_body_assumptions
tab independent_body_implementation
gen independent_body_rescaled=(independent_body_assumptions+independent_body_implementation)/2

**Formal enforcement procedure
tab bbr_national_enforcement

**Escape clause
tab bbr_national_escape_clause
gen bbr_national_esc_clause_rescale=bbr_national_escape_clause*2

**Budget balance rule defined in cyclically adjusted terms
tab bbr_national_cyclically_adjusted
gen bbr_national_cycl_adjstd_rescale=bbr_national_cyclically_adjusted*2

**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen bbr_national_scaled=bbr_national_legal_rescaled+bbr_national_monitoring+independent_body_rescaled+bbr_national_enforcement+bbr_national_esc_clause_rescale+bbr_national_cycl_adjstd_rescale +independence_rescaled + council_monitoring

tab bbr_national_scaled

keep country year bbr_national_scaled
replace bbr_national_scaled=0 if bbr_national_scaled==.
save lu_bbr_national, replace



**2) DR, National
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.

keep if dr_rule_in_place==1
keep year country dr* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if dr_supranational==1
keep if year>1996

**Legal basis
tab dr_national_legal_basis
**Ranges from 0-5, rescale from 0-1
gen dr_national_legal_rescaled=dr_national_legal_basis/5

**Monitoring mechanism outside the government 
tab dr_national_monitoring

**Independent body setting budget assumptions and monitoring budget implementation 
tab independent_body_assumptions
tab independent_body_implementation
gen independent_body_rescaled=(independent_body_assumptions+independent_body_implementation)/2

**Formal enforcement procedure
tab dr_national_enforcement

**Escape clause
tab dr_national_escape_clause
destring dr_national_escape_clause, force replace
gen dr_national_esc_clause_rescale=dr_national_escape_clause*2

 
**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen dr_national_scaled=dr_national_legal_rescaled+dr_national_monitoring+independent_body_rescaled+dr_national_enforcement+dr_national_esc_clause_rescale +independence_rescaled + council_monitoring

tab dr_national_scaled

keep country year dr_national_scaled
replace dr_national_scaled=0 if dr_national_scaled==.
save lu_dr_national, replace


**3) ER, National
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.

keep if er_rule_in_place==1
keep year country er* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if er_supranational==1
keep if year>1996

**Legal basis
tab er_national_legal_basis
**Ranges from 0-5, rescale from 0-1
gen er_national_legal_rescaled=er_national_legal_basis/5

**Monitoring mechanism outside the government 
tab er_national_monitoring

**Independent body setting budget assumptions and monitoring budget implementation 
tab independent_body_assumptions
tab independent_body_implementation
gen independent_body_rescaled=(independent_body_assumptions+independent_body_implementation)/2

**Formal enforcement procedure
tab er_national_enforcement

**Escape clause
tab er_national_escape_clause
destring er_national_escape_clause, force replace
gen er_national_esc_clause_rescale=er_national_escape_clause*2

 
**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen er_national_scaled=er_national_legal_rescaled+er_national_monitoring+independent_body_rescaled+er_national_enforcement+er_national_esc_clause_rescale +independence_rescaled + council_monitoring

tab er_national_scaled

keep country year er_national_scaled
replace er_national_scaled=0 if er_national_scaled==.
save lu_er_national, replace


**4) rr, National
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.

keep if rr_rule_in_place==1
keep year country rr* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if rr_supranational==1
keep if year>1996

**Legal basis
tab rr_national_legal_basis
**Ranges from 0-5, rescale from 0-1
gen rr_national_legal_rescaled=rr_national_legal_basis/5

**Monitoring mechanism outside the govrrnment 
tab rr_national_monitoring

**Independent body setting budget assumptions and monitoring budget implementation 
tab independent_body_assumptions
tab independent_body_implementation
gen independent_body_rescaled=(independent_body_assumptions+independent_body_implementation)/2

**Formal enforcement procedure
tab rr_national_enforcement

**Escape clause
tab rr_national_escape_clause
destring rr_national_escape_clause, force replace
gen rr_national_esc_clause_rescale=rr_national_escape_clause*2

**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen rr_national_scaled=rr_national_legal_rescaled+rr_national_monitoring+independent_body_rescaled+rr_national_enforcement+rr_national_esc_clause_rescale +independence_rescaled + council_monitoring

tab rr_national_scaled

keep country year rr_national_scaled
replace rr_national_scaled=0 if rr_national_scaled==.
save lu_rr_national, replace


***Combine All National Rule Scores:
use base_fiscal_rule_index_analysis_table, replace
keep year country
bysort year country: keep if _n==1
merge 1:1 year country using lu_bbr_national
replace bbr_national_scaled=0 if bbr_national_scaled==.
drop _merge
merge 1:1 year country using lu_dr_national
replace dr_national_scaled=0 if dr_national_scaled==.
drop _merge
merge 1:1 year country using lu_er_national
replace er_national_scaled=0 if er_national_scaled==.
drop _merge
merge 1:1 year country using lu_rr_national
replace rr_national_scaled=0 if rr_national_scaled==.
drop _merge
save lu_fiscal_rule_scores_national, replace

tab country
/*
- Still not sure about national vs supranational. 
- Also, what is this:
The score for each type of rule is calculated by summing up the scores of each criterion, which gives a
theoretical maximum value of 10. Then, different coverage in each type of fiscal rule will be weighted with
general government assigned a weight of 1 while the central government is assigned a weight of 0.75. This
captures in spirit that higher coverage of the fiscal rules would indicate a potentially stronger fiscal rule that
applies to a wider set of fiscal aggregates
- Finally, weighting for multiple rules


**I think for the national vs supranational issue, I only include the highest-scoring of the two for each type of rule (so, if a country has a national and supranational bbr, I only include one). Then, the normal weighting of 1, 1/2, 1/3, 1/4 will apply.
*/

********************************************************
**Supranational Rules
*********************************************************
**1) BBR, Supranational
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.


keep if bbr_rule_in_place==1
keep year country bbr* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if bbr_supranational==0
keep if year>1996

**Legal basis
tab bbr_supranational_legal_basis
**Ranges from 0-5, rescale from 0-1
gen bbr_supranational_legal_rescaled=bbr_supranational_legal_basis/5

**Monitoring mechanism outside the government 
tab bbr_supranational_monitoring

**Formal enforcement procedure
tab bbr_supranational_enforcement

**Escape clause
tab bbr_supranational_escape_clause
gen bbr_supra_esc_clause_rescale=bbr_supranational_escape_clause*2

**Budget balance rule defined in cyclically adjusted terms
tab bbr_supranational_cyclically_adj
gen bbr_supra_cycl_adjstd_rescale=bbr_supranational_cyclically_adj*2

**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen bbr_supranational_scaled=bbr_supranational_legal_rescaled+bbr_supranational_monitoring+bbr_supranational_enforcement+bbr_supra_esc_clause_rescale+bbr_supra_cycl_adjstd_rescale +independence_rescaled + council_monitoring

tab bbr_supranational_scaled

keep country year bbr_supranational_scaled
replace bbr_supranational_scaled=0 if bbr_supranational_scaled==.
save lu_bbr_supranational, replace



**2) DR, Supranational
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.

keep if dr_rule_in_place==1
keep year country dr* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if dr_supranational==0
keep if year>1996

**Legal basis
tab dr_supranational_legal_basis
**Ranges from 0-5, rescale from 0-1
gen dr_supranational_legal_rescaled=dr_supranational_legal_basis/5

**Monitoring mechanism outside the government 
tab dr_supranational_monitoring

 
**Formal enforcement procedure
tab dr_supranational_enforcement

**Escape clause
tab dr_supranational_escape_clause
destring dr_supranational_escape_clause, force replace
gen dr_supra_esc_clause_rescale=dr_supranational_escape_clause*2

 
**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen dr_supranational_scaled=dr_supranational_legal_rescaled+dr_supranational_monitoring+dr_supranational_enforcement+dr_supra_esc_clause_rescale +independence_rescaled + council_monitoring

tab dr_supranational_scaled

keep country year dr_supranational_scaled
replace dr_supranational_scaled=0 if dr_supranational_scaled==.
save lu_dr_supranational, replace


**3) ER, Supraational
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.

keep if er_rule_in_place==1
keep year country er* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if er_supranational==0
keep if year>1996

**Legal basis
tab er_supranational_legal_basis
**Ranges from 0-5, rescale from 0-1
gen er_supranational_legal_rescaled=er_supranational_legal_basis/5

**Monitoring mechanism outside the government 
tab er_supranational_monitoring
replace er_supranational_monitoring=1 if er_supranational_monitoring>1
 
**Formal enforcement procedure
tab er_supranational_enforcement

**Escape clause
tab er_supranational_escape_clause
destring er_supranational_escape_clause, force replace
replace er_supranational_escape_clause=1 if er_supranational_escape_clause>1
gen er_supra_esc_clause_rescale=er_supranational_escape_clause*2

 
**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen er_supranational_scaled=er_supranational_legal_rescaled+er_supranational_monitoring+er_supranational_enforcement+er_supra_esc_clause_rescale +independence_rescaled + council_monitoring

tab er_supranational_scaled

keep country year er_supranational_scaled
replace er_supranational_scaled=0 if er_supranational_scaled==.
save lu_er_supranational, replace


**4) rr, Supranational
use base_fiscal_rule_index_analysis_table, replace
merge m:1 country using base_fiscal_council_index_analysis_table
tab coverage
gen general_central_gvmnt_weight=1
replace general_central_gvmnt_weight=.75 if inlist(coverage,"Central government","Central government + BPS")
replace general_central_gvmnt_weight=0 if coverage==""
drop _merge
replace council_monitoring =0 if council_monitoring   ==.
replace independence_legal =0 if  independence_legal  ==.
replace independence_operational =0 if  independence_operational  ==.

keep if rr_rule_in_place==1
keep year country rr* independent_body_assumptions independent_body_implementation council_monitoring independence_legal independence_operational year_start general_central_gvmnt_weight
drop if rr_supranational==0
keep if year>1996

**Legal basis
tab rr_supranational_legal_basis
**Ranges from 0-5, rescale from 0-1
gen rr_supranational_legal_rescaled=rr_supranational_legal_basis/5

**Monitoring mechanism outside the govrrnment 
tab rr_supranational_monitoring

 
**Formal enforcement procedure
tab rr_supranational_enforcement

**Escape clause
tab rr_supranational_escape_clause
destring rr_supranational_escape_clause, force replace
gen rr_supra_esc_clause_rescale=rr_supranational_escape_clause*2

**Independence – Legal & Operational
gen independence_rescaled=general_central_gvmnt_weight*(independence_legal+independence_operational)/2
replace independence_rescaled=0 if year_start>year
 
**Monitoring of Fiscal Rules
tab council_monitoring
replace council_monitoring=council_monitoring*general_central_gvmnt_weight
replace council_monitoring=0 if year_start>year


gen rr_supranational_scaled=rr_supranational_legal_rescaled+rr_supranational_monitoring+rr_supranational_enforcement+rr_supra_esc_clause_rescale +independence_rescaled + council_monitoring

tab rr_supranational_scaled

keep country year rr_supranational_scaled
replace rr_supranational_scaled=0 if rr_supranational_scaled==.
save lu_rr_supranational, replace


***Combine All Rule Scores:
use base_fiscal_rule_index_analysis_table, replace
keep year country
bysort year country: keep if _n==1
merge 1:1 year country using lu_bbr_national
replace bbr_national_scaled=0 if bbr_national_scaled==.
drop _merge
merge 1:1 year country using lu_dr_national
replace dr_national_scaled=0 if dr_national_scaled==.
drop _merge
merge 1:1 year country using lu_er_national
replace er_national_scaled=0 if er_national_scaled==.
drop _merge
merge 1:1 year country using lu_rr_national
replace rr_national_scaled=0 if rr_national_scaled==.
drop _merge
merge 1:1 year country using lu_bbr_supranational
replace bbr_supranational_scaled=0 if bbr_supranational_scaled==.
drop _merge
merge 1:1 year country using lu_dr_supranational
replace dr_supranational_scaled=0 if dr_supranational_scaled==.
drop _merge
merge 1:1 year country using lu_er_supranational
replace er_supranational_scaled=0 if er_supranational_scaled==.
drop _merge
merge 1:1 year country using lu_rr_supranational
replace rr_supranational_scaled=0 if rr_supranational_scaled==.
drop _merge
save lu_fiscal_rule_scores_all, replace

**Combine Scores:
use lu_fiscal_rule_scores_all, replace
gen bbr_max=max(bbr_national_scaled, bbr_supranational_scaled)
gen dr_max=max(dr_national_scaled, dr_supranational_scaled)
gen er_max=max(er_national_scaled, er_supranational_scaled)
gen rr_max=max(rr_national_scaled, rr_supranational_scaled)
keep year country *_max
keep if  bbr_max+dr_max+er_max+rr_max>0
save lu_fiscal_rule_scores_max, replace



local varlist bbr rr er dr
foreach v of local varlist{
use lu_fiscal_rule_scores_max, replace
keep year country `v'_max
rename `v'_max score
gen rule="`v'"
save `v', replace
}


use bbr, replace
append using rr
append using er
append using dr
drop if score==0
bysort year country: gen number_rules=_N
gen score_rank=score*-1
sort country year score_rank
bysort country year: gen rank=_n
drop score_rank
gen weight=1/rank
gen weighted_score=weight*score
tab weighted_score
sort weighted_score
keep year country weighted_score
sort country year
gen weighted_score_rescaled=weighted_score 
drop weighted_score
gen countryname=country
tab countryname
replace countryname="argentina" if countryname=="Argentina"
replace countryname="armenia" if countryname=="Armenia"
replace countryname="azerbaijan" if countryname=="Azerbaijan"
replace countryname="brazil" if countryname=="Brazil"
replace countryname="cameroon" if countryname=="Cameroon"
replace countryname="chile" if countryname=="Chile"
replace countryname="colombia" if countryname=="Colombia"
replace countryname="costarica" if countryname=="Costa Rica"
sort country
replace countryname="cotedivoire" if strmatch(countryname, "*d'Ivoire")
replace countryname="croatia" if countryname=="Croatia"
replace countryname="ecuador" if countryname=="Ecuador"
replace countryname="gabon" if countryname=="Gabon"
replace countryname="georgia" if countryname=="Georgia"
replace countryname="hungary" if countryname=="Hungary"
replace countryname="india" if countryname=="India"
replace countryname="indonesia" if countryname=="Indonesia"
replace countryname="jamaica" if countryname=="Jamaica"
replace countryname="kazakhstan" if countryname=="Kazakhstan"
replace countryname="kenya" if countryname=="Kenya"
replace countryname="lithuania" if countryname=="Lithuania"
replace countryname="malaysia" if countryname=="Malaysia"
replace countryname="mexico" if countryname=="Mexico"
replace countryname="mongolia" if countryname=="Mongolia"
replace countryname="namibia" if countryname=="Namibia"
replace countryname="nigeria" if countryname=="Nigeria"
replace countryname="pakistan" if countryname=="Pakistan"
replace countryname="panama" if countryname=="Panama"
replace countryname="paraguay" if countryname=="Paraguay"
replace countryname="peru" if countryname=="Peru"
replace countryname="poland" if countryname=="Poland"
replace countryname="romania" if countryname=="Romania"
replace countryname="russia" if countryname=="Russia"
replace countryname="senegal" if countryname=="Senegal"
replace countryname="serbia" if countryname=="Serbia"
replace countryname="slovakia" if countryname=="Slovak Republic"
replace countryname="srilanka" if countryname=="Sri Lanka"
replace countryname="uruguay" if countryname=="Uruguay"
replace countryname="vietnam" if countryname=="Vietnam"
drop country
rename  countryname country
save lu_strength_of_rule, replace

use "..\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
keep country fiscal_rule_any
keep if fiscal_rule_any==1
bysort country: keep if _n==1
keep country
save countries_with_rules, replace

use lu_strength_of_rule, replace
merge m:1 country using countries_with_rules
keep if _merge==3
drop _merge
order year country
sort  country year
collapse (sum) weighted_score_rescaled=weighted_score_rescaled, by(year country)
gen group=1
bysort group: egen max_score=max(weighted_score_rescaled)
replace weighted_score_rescaled=weighted_score_rescaled/max_score
tab weighted_score_rescaled
drop group max_score
bysort year country: gen count=_N
drop count
save lu_strength_of_rule_to_21, replace

use lu_strength_of_rule_to_21, replace
keep if year==2021
replace year=2022
append using lu_strength_of_rule_to_21
save lu_strength_of_rule_final.dta, replace



use lu_strength_of_rule_final, replace
replace year=year+1
keep if year>2018 & year<2023
rename weighted_score_rescaled weighted_score_rescaled_lag
save lu_strength_of_rule_final_lag, replace


 


