*ssc install reghdfe
*ssc install estout
*ssc install ftools
*ssc install legend
*pwd
 cd ".\Files for Reproduction - GFC Spreads\"

clear
 insheet using "EMBI_all_countries_clean.csv",names
save embi_all_countries, replace

use embi_all_countries, replace
 browse
 keep date  argentinastwtrsy	belarusstwtrsy	belizestwtrsy	brazilstwtrsy	bulgariastwtrsy	chilestwtrsy	chinastwtrsy	colombiastwtrsy	croatiastwtrsy	dominicanrepublicstwtrsy	ecuadorstwtrsy	egyptstwtrsy	elsalvadorstwtrsy	gabonstwtrsy	georgiastwtrsy	ghanastwtrsy	hungarystwtrsy	indonesiastwtrsy	iraqstwtrsy	jamaicastwtrsy	kazakhstanstwtrsy	lebanonstwtrsy	lithuaniastwtrsy	malaysiastwtrsy	mexicostwtrsy	pakistanstwtrsy	panamastwtrsy	perustwtrsy	philippinesstwtrsy	polandstwtrsy	russiastwtrsy	serbiastwtrsy	southafricastwtrsy	srilankastwtrsy	tunisiastwtrsy	turkeystwtrsy	ukrainestwtrsy	uruguaystwtrsy	venezuelastwtrsy	vietnamstwtrsy

 
local varlist belarus	belize	croatia	gabon	georgia	ghana	jamaica	kazakhstan	lithuania	srilanka
foreach v of local varlist{
destring `v'stwtrsy, generate(`v'stwtrsy_clean) ignore("N/A")
drop  `v'stwtrsy
rename `v'stwtrsy_clean `v'stwtrsy
} 
 
 
local varlist argentina	belarus	belize	brazil	bulgaria	chile	china	colombia	croatia	dominicanrepublic	ecuador	egypt	elsalvador	gabon	georgia	ghana	hungary	indonesia	iraq	jamaica	kazakhstan	lebanon	lithuania	malaysia	mexico	pakistan	panama	peru	philippines	poland	russia	serbia	southafrica	srilanka	tunisia	turkey	ukraine	uruguay	venezuela	vietnam
foreach v of local varlist{
rename `v'stwtrsy stwtrsy`v'
} 
 

*Formate date field
gen date2=date(date,"MDY") 
format date2 %d
drop date
rename date2 date
order date   
reshape long stwtrsy  , i(date) j(country) string
order date country stwtrsy
sort country date

**Flag countries that make this an unbalanced panel
gen flag_country_missing_some_dates=0
replace flag_country_missing_some_dates=1 if inlist(country,"belarus","belize","croatia","gabon","georgia")
replace flag_country_missing_some_dates=1 if inlist(country,"ghana","jamaica","kazakhstan","lithuania","srilanka")
 
 
*Construct our spread variable of interest
gen logspread=log(stwtrsy)
bysort country: gen lag_spread=logspread[_n-1]
gen current_spread=logspread


gen change_spread=current_spread-lag_spread
drop stwtrsy  
drop logspread
bysort country: gen lag_change_spread=change_spread[_n-1]

  save Analysis_Expanded_Spreads_Initial_logs_May_2023 , replace
  sort country date
 
    
  
 
 *Create Lookup With History of Fiscal Rules
   clear
 insheet using "Fiscal_Rules_All_Countries_Flagged_0609_2022.csv",names
replace countryname="argentina" if countryname=="Argentina"
replace countryname="armenia" if countryname=="Armenia"
replace countryname="azerbaijan" if countryname=="Azerbaijan"
replace countryname="brazil" if countryname=="Brazil"
replace countryname="bulgaria" if countryname=="Bulgaria"
replace countryname="cameroon" if countryname=="Cameroon"
replace countryname="chile" if countryname=="Chile"
replace countryname="colombia" if countryname=="Colombia"
replace countryname="costarica" if countryname=="Costa Rica"
replace countryname="cotedivoire" if country==26
replace countryname="croatia" if countryname=="Croatia"
replace countryname="ecuador" if countryname=="Ecuador"
replace countryname="gabon" if countryname=="Gabon"
replace countryname="georgia" if countryname=="Georgia"
replace countryname="hungary" if countryname=="Hungary"
replace countryname="india" if countryname=="India"
replace countryname="indonesia" if countryname=="Indonesia"
replace countryname="jamaica" if countryname=="Jamaica"
replace countryname="kazakhstan" if countryname=="Kazakhstan"
replace countryname="kenya" if countryname=="Kenya"
replace countryname="lithuania" if countryname=="Lithuania"
replace countryname="malaysia" if countryname=="Malaysia"
replace countryname="mexico" if countryname=="Mexico"
replace countryname="mongolia" if countryname=="Mongolia"
replace countryname="namibia" if countryname=="Namibia"
replace countryname="nigeria" if countryname=="Nigeria"
replace countryname="pakistan" if countryname=="Pakistan"
replace countryname="panama" if countryname=="Panama"
replace countryname="paraguay" if countryname=="Paraguay"
replace countryname="peru" if countryname=="Peru"
replace countryname="poland" if countryname=="Poland"
replace countryname="romania" if countryname=="Romania"
replace countryname="russia" if countryname=="Russia"
replace countryname="senegal" if countryname=="Senegal"
replace countryname="serbia" if countryname=="Serbia"
replace countryname="slovakia" if countryname=="Slovak Republic"
replace countryname="srilanka" if countryname=="Sri Lanka"
replace countryname="uruguay" if countryname=="Uruguay"
replace countryname="vietnam" if countryname=="Vietnam"
drop country
rename countryname country

replace erexpenditurerule ="0" if erexpenditurerule =="-"
replace rrrevenuerule ="0" if rrrevenuerule =="-"
replace bbrbudgetbalancerule ="0" if bbrbudgetbalancerule =="-"
replace drdebtrule ="0" if drdebtrule =="-"
***
replace escapeclauseorsuspension=1 if escapeclauseorsuspension>=1
gen fiscal_rule_any=0
replace fiscal_rule_any=1 if erexpenditurerule =="1"|rrrevenuerule =="1"|bbrbudgetbalancerule =="1"|drdebtrule =="1"
destring erexpenditurerule, generate(erexpenditurerule_clean) ignore("N/A" "..")
destring rrrevenuerule, generate(rrrevenuerule_clean) ignore("N/A" "..")
destring bbrbudgetbalancerule, generate(bbrbudgetbalancerule_clean) ignore("N/A" "..")
destring drdebtrule, generate(drdebtrule_clean) ignore("N/A" "..")
drop erexpenditurerule
drop rrrevenuerule
drop bbrbudgetbalancerule
drop drdebtrule
rename erexpenditurerule_clean erexpenditurerule
rename rrrevenuerule_clean rrrevenuerule
rename bbrbudgetbalancerule_clean bbrbudgetbalancerule
rename drdebtrule_clean drdebtrule


keep year country fiscal_rule_any escapeclauseorsuspension erexpenditurerule rrrevenuerule bbrbudgetbalancerule drdebtrule escapeclause suspension nationalrule
save LU_Fiscal_Rules, replace 

 
use LU_Fiscal_Rules, replace
replace year=year+1
rename fiscal_rule_any lagged_fiscal_rule_any
keep year country lagged_fiscal_rule_any
save LU_Fiscal_Rules_Lagged, replace 


  
  use Analysis_Expanded_Spreads_Initial_logs_May_2023, replace 
sort date country 
by date: gen country_id=_n
 xtset country_id  date
  gen month=month(date)
 gen year=year(date)


  
save Spreads_Analysis_Expanded_Empirical_Tests_1_Extend_2010, replace
 
 /*
 Flag ECB and Fed Action
 */
  clear
insheet using "Fed_ECB_Policy_Decisions_GFC.csv", names
rename fed fedaction
rename ecb ecbaction
replace fedaction=0 if fedaction==.
replace ecbaction=0 if ecbaction==.
gen date2=date(date,"MDY") 
format date2 %d
drop date
rename date2 date
save LU_Fed_ECB_Actions, replace

 
   clear
insheet using "Reinhart_External_Debt_Default_Dummies_Formatted.csv", names
drop country
rename v3 country
drop if country==""
drop shareofworldgdpasof1913 shareofworldgdpasof1990 shareofworldgdpasof2003
destring year_1802, gen(year_1802_clean)
 drop year_1802
 rename year_1802_clean year_1802
destring year_1900, gen(year_1900_clean)
 drop year_1900
 rename year_1900_clean year_1900
 replace noofyearssinceindependenceor1800=noofyearssinceindependenceor1800-8
 drop year_2007 year_2008 year_2009 year_2010 year_2011 year_2012 year_2013 year_2014
drop noofyearsindefault
egen noofyearsindefault=rowtotal(year_*)
replace pdefault= (noofyearsindefault/noofyearssinceindependenceor1800)*100
reshape long  year_ , i(region country yearofindependence noofyearssinceindependenceor1800 noofyearsindefault pdefault) j(default) string
rename default year
rename year_ default_external_flag

destring year, gen(year_clean)
 drop year
 rename year_clean year

 replace yearofindependence="1591" if yearofindependence=="1591/1957"
 destring yearofindependence, gen(yearofindependence_clean)
 
 drop yearofindependence
 rename yearofindependence yearofindependence
  drop if year>2006
  sort country year 
generate yearssinceindependenceor1800=2006-yearofindependence+1
 replace yearssinceindependenceor1800=207 if yearssinceindependenceor1800>213
 keep country year yearssinceindependenceor1800 default_external_flag
 save LU_Defaults_External_Debt, replace
 
 
   clear
insheet using "Reinhart_Domestic_Debt_Default_Dummies_Formatted.csv", names
drop country
rename v3 country
drop if country==""
replace noofyearssinceindependenceor1800=noofyearssinceindependenceor1800-6
drop year_2007 year_2008 year_2009 year_2010 year_2011 year_2012
drop noofyearsindefault
egen noofyearsindefault=rowtotal(year_*)
replace pdefault= (noofyearsindefault/noofyearssinceindependenceor1800)*100


drop shareofworldgdpasof1913 shareofworldgdpasof1990 shareofworldgdpasof2003
reshape long  year_ , i(region country yearofindependence noofyearssinceindependenceor1800 noofyearsindefault pdefault) j(default) string
rename default year
rename year_ default_domestic_flag

destring year, gen(year_clean)
 drop year
 rename year_clean year
 drop v224 v225 v226 v227
  destring yearofindependence, gen(yearofindependence_clean)
 drop yearofindependence
 rename yearofindependence yearofindependence
  drop if year>2006  
  sort country year 
replace noofyearssinceindependenceor1800=noofyearssinceindependenceor1800-6
 keep country year default_domestic_flag
 save LU_Defaults_Domestic_Debt, replace
 
 merge 1:1 country year using LU_Defaults_External_Debt
 drop _merge
 gen default_any=0
 replace default_any=1 if default_domestic_flag==1 | default_external_flag==1
* replace yearssinceindependenceor1800=38 if country=="suriname"
bysort country: egen total_defaults_any=sum(default_any)
gen pdefault_any=(total_defaults/yearssinceindependenceor1800)*100
 
bysort country: egen total_defaults_external=sum(default_external)
gen pdefault_external=(total_defaults_external/yearssinceindependenceor1800)*100
 
bysort country: egen total_defaults_domestic=sum(default_domestic)
gen pdefault_domestic=(total_defaults_domestic/yearssinceindependenceor1800)*100
  
keep country   pdefault_any pdefault_external pdefault_domestic
 replace  pdefault_external=. if country=="suriname"
 bysort country: keep if _n==1
save LU_Prob_Default_1800_2006, replace
 

/*
Incorporate Month Dummies and WEO Data from 2019-2022
*/  
use Spreads_Analysis_Expanded_Empirical_Tests_1_Extend_2010, replace  
keep month year
bysort year month: keep if _n==1
 gen year_month=_n 
save LU_year_month, replace

do LU_WEO_Data_2006_2010.do


/*
Create LU With Soveriegn Credit Ratings
*/

use Fiscal-space-data, replace

keep ifscode country sovrate xtdebty fordebtsh cby pby debtduey year 
keep   if year>2005 & year<2010
rename country country_worldbank
drop ifscode
replace year=year+1
rename sovrate sovrate_lagged
rename xtdebty xtdebty_lagged
rename fordebtsh fordebtsh_lagged
rename cby cby_lagged
rename pby pby_lagged
rename debtduey debtduey_lagged
save LU_sovereign_ratings_lagged, replace

 
use Fiscal-space-data, replace
keep ifscode country sovrate xtdebty fordebtsh cby pby debtduey year 
keep   if year>2006 & year<2011
rename country country_worldbank
drop ifscode
save LU_sovereign_ratings, replace
 clear 
 import excel LU_world_bank_income_geography_classification.xlsx ,  firstrow case(lower)
save LU_world_bank_income_geography_classification, replace

clear
 import excel LU_countryname_crosswalk.xlsx ,  firstrow case(lower)
save LU_countryname_crosswalk, replace

*do Create GDP Per Capita Inflation LUs.do
use Spreads_Analysis_Expanded_Empirical_Tests_1_Extend_2010, replace 


 merge m:1 country using LU_world_bank_income_geography_classification
 drop _merge
 tab income_status
 
 gen geography_id=0
 replace geography_id=1 if geography=="Europe and Central Asia"
 replace geography_id=2 if geography=="Latin America and the Caribbean"
 replace geography_id=3 if geography=="Middle East and North Africa"
 replace geography_id=4 if geography=="South Asia"
 replace geography_id=5 if geography=="Sub-Saharan Africa"
 
  gen income_id=0
 replace income_id=1 if income_status=="Lower middle income"
 replace income_id=2 if income_status=="Upper middle income"
 replace income_id=3 if income_status=="High income"
drop if date==.
save  Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2010, replace
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2010, replace
 bysort country geography: keep if _n==1

 *****************************************************
*GDP and inflation LUs
do "Create Inflation GDP LUs.do"
 
*Regional Factor 
 do LU_Govt_Effectiveness.do

 *Join on Fiscal Rule Flags
use LU_Fiscal_Rules_Thru_2022, replace
replace country="bulgaria" if country=="Bulgaria"
save LU_Fiscal_Rules_Thru_2010, replace
 
 bysort country: keep if _n==	1
*Start here to finish script:
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2010, replace 
merge m:1 year month using LU_year_month
drop _merge

merge m:1 year country using LU_Govt_Effectiveness
drop _merge
drop if date==.
 
 
 
merge m:1 country using LU_countryname_crosswalk
drop if _merge==2
drop _merge

merge m:1 country_worldbank year using LU_sovereign_ratings
 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge
 

 merge m:1 country_worldbank year using LU_sovereign_ratings_lagged
 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge

 
**Here SJS May 18************************************

  merge m:1 country year using LU_GDP
 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge
 
   merge m:1 country year using LU_Inflation
 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge
 


merge m:1 year country     using LU_Fiscal_Rules_Thru_2022 
replace fiscal_rule_any=0 if fiscal_rule_any==.
replace escapeclauseorsuspension=0 if escapeclauseorsuspension==.
replace erexpenditurerule=0 if erexpenditurerule==.
replace rrrevenuerule=0 if rrrevenuerule==.
replace bbrbudgetbalancerule=0 if bbrbudgetbalancerule==.
replace drdebtrule=0 if drdebtrule==.
replace nationalrule=0 if nationalrule==.
replace suspension=0 if suspension==.
replace escapeclause=0 if escapeclause==.


 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge

merge m:1 year country     using LU_Fiscal_Rules_Lagged 
replace lagged_fiscal_rule_any=0 if lagged_fiscal_rule_any==.
 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge
 
 
*Join on prior year's debt and deficit
gen year_join=year 
merge m:1 year_join country using LU_WEO_Data_Current_Period
 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge
 
 merge m:1 year_join country using LU_WEO_Data_Lagged
 tostring _merge, gen(merge)
 drop if merge=="2"
 drop _merge merge

 
 
 *Debt and Deficit Monthly Interactions
local varlist   2007 2008 2009 2010 
foreach y of local varlist{ 
local varlist2 1 2 3 4 5 6 7 8 9 10 11 12
foreach m of local varlist2{
gen debt_`y'_month_`m'=0
replace debt_`y'_month_`m'=gross_debt_WEO_lag if year==`y' & month==`m'
gen budget_balance_`y'_month_`m'=0
replace budget_balance_`y'_month_`m'=budget_balance_WEO_lag if year==`y' & month==`m' 
gen primary_balance_`y'_month_`m'=0
replace primary_balance_`y'_month_`m'=primary_budget_balance_WEO_lag if year==`y' & month==`m' 
 }
 }
 drop debt_2007_month_1 
 drop  budget_balance_2007_month_1
 drop  primary_balance_2007_month_1
 
 *Join history of debt crises:
 merge m:1 country using LU_Prob_Default_1800_2006
 drop if _merge==2
 drop _merge  
 
 
 local varlist 2007 2008 2009 2010
foreach y of local varlist{ 
local varlist2 1 2 3 4 5 6 7 8 9 10 11 12
foreach m of local varlist2{
gen debt_crisis_pct_`y'_month_`m'=0
replace debt_crisis_pct_`y'_month_`m'=pdefault_any if year==`y' & month==`m'
 }
 }
 drop debt_crisis_pct_2007_month_1 
 

gen fiscal_rule_no_suspension=0
replace fiscal_rule_no_suspension=1 if escapeclauseorsuspension==0 & fiscal_rule_any==1

merge m:1 date using LU_Fed_ECB_Actions
 tostring _merge, gen(merge)
 drop if merge=="2"
drop merge _merge

 
gen fiscal_rule_ger_interact= fiscal_rule_any*ger
gen fiscal_rule_rlr_interact= fiscal_rule_any*rlr
gen fiscal_rule_ccr_interact= fiscal_rule_any*ccr

 
 save Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2010_May_23, replace
  use Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2010_May_23, replace

 
