*Create LU With GDP by Country
clear
import excel using "GDP per capita World Bank.xlsx" ,  firstrow case(lower)
browse
drop seriesname seriescode
drop if countryname==""
 

 reshape long yr  , i(countryname countrycode) j(gdp)  
 rename yr gdp_per_cap_growth
 rename gdp year
rename countryname country
 

 sort year countrycode
 by year: gen country_id=_n
 
drop countrycode
order country_id country

xtset country_id year
gen gdp_per_cap_growth_lag=L1.gdp_per_cap_growth
 keep if year>2006 & year<2011
 
 rename country country_worldbank
merge m:1 country_worldbank using LU_countryname_crosswalk
replace country="russia" if country_worldbank=="Russia"
replace country="turkey" if country_worldbank=="Turkiye"

keep if country!=""
drop if year==.
keep year gdp_per_cap_growth gdp_per_cap_growth_lag country
 save LU_GDP, replace
 
*Create similar table with inflation:
clear
 import excel using "World Bank Inflation backfilled.xlsx" ,  firstrow case(lower) 
 browse
 drop yr2020 yr2021
drop seriesname seriescode
drop if countryname==""
 
local varlist 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011 2012 2013 2014 2015 2016 2017 2018 2019 
foreach v of local varlist{
destring yr`v', generate(yr`v'_clean) ignore("N/A" "n/a" )
drop yr`v'
rename  yr`v'_clean yr`v'
replace yr`v'=yr`v'/100 
}
 
 reshape long yr  , i(countryname countrycode) j(inflation)  
  rename inflation year
 rename yr inflation
rename countryname country
 sort year countrycode
 by year: gen country_id=_n
 
drop countrycode
order country_id country

xtset country_id year

gen inflation_lagged=L1.inflation
drop country_id
replace country="Congo, Republic of" if country=="Congo, Rep."
replace country="Guinea Bissau" if country=="Guinea-Bissau"
replace country="Hong Kong SAR" if country=="Hong Kong SAR, China"
replace country="Iran" if country=="Iran, Islamic Rep."
replace country="Montenegro, Rep. of" if country=="Montenegro"
replace country="Russia" if country=="Russian Federation"
 keep if year>2006 & year<2011
rename country country_worldbank
merge m:1 country_worldbank using LU_countryname_crosswalk
replace country="russia" if country_worldbank=="Russia"
replace country="turkey" if country_worldbank=="Turkiye"

keep if country!=""
drop if year==.
keep country year inflation inflation_lagged
 save LU_Inflation, replace
 
 