clear

use ".\Files for Reproduction - GFC Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2010_May_23.dta", replace
drop if date==.
drop if current_spread==.
tab country
**Make this a balanced panel
drop if inlist(country,"georgia","belarus","ghana","srilanka","jamaica","belize","kazakhstan","gabon")
drop if income_status=="High income"
drop if date>=date("20100101","YMD") 
 ******************************************************************************************************
**1) Baseline (Controlling for Government Effectiveness)
******************************************************************************************************
label variable ger "Government Effectiveness"
label variable xtdebty_lagged "Total External Debt Stocks"
label variable pby_lagged "Primary Balance"
label variable fiscal_rule_any "Fiscal Rule"
label variable inflation_lagged "Inflation"
label variable perc_change_GDP_percap_WEO_lag "GDP Per Capita Growth"
label variable ecbaction "ECB Policy Dummy"
label variable fedaction "Fed Policy Dummy"

*Everything in Levels
eststo reg2b: quietly reg current_spread fiscal_rule_any ger	 		i.year_month	 i.country_id	 if income_status !="High income" 	 
eststo reg4b: quietly reg current_spread fiscal_rule_any ger	 		xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 	 

eststo reg5b: quietly reg current_spread fiscal_rule_any ger	 		perc_change_GDP_percap_WEO_lag	inflation_lagged	i.year_month	 i.country_id	 if income_status !="High income" 	 
	
eststo reg7b: quietly reg current_spread fiscal_rule_any ger	 		xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lagged	i.year_month	 i.country_id	 if income_status !="High income"  


esttab    reg2b   reg4b reg5b   reg7b     using ".\Output\Table_A5.rtf", replace r2(4)   starl( * 0.10 ** 0.05 *** 0.010)  drop(_cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(fiscal_rule_any   ger perc_change_GDP_percap_WEO_lag inflation_lagged pby_lagged  xtdebty_lagged  ) indicate("Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")  compress label ///
title(Table A5. Panel Regression Estimates of Fiscal Rule Impact on Sovereign Spreads During GFC) ///
nonumbers
  
 
******************************************************************************************************
**2) Diff-in-Diff looking at pre- and post-crisis:
******************************************************************************************************
gen post_crisis=0
replace post_crisis=1 if date>=date("20080301","YMD") 
gen fiscal_rule_post_crisis=fiscal_rule_any*post_crisis
label variable fiscal_rule_post_crisis "Fiscal Rule#Post GFC"
label variable post_crisis "Post GFC"


*Everything in Levels
eststo reg12b: quietly reg current_spread fiscal_rule_any post_crisis fiscal_rule_post_crisis ger	 		 	 i.country_id	 if income_status !="High income" 	
eststo reg14b: quietly reg current_spread fiscal_rule_any post_crisis fiscal_rule_post_crisis ger	 		xtdebty_lagged	pby_lagged	 	 i.country_id	 if income_status !="High income" 		
eststo reg15b: quietly reg current_spread fiscal_rule_any post_crisis fiscal_rule_post_crisis ger	 		perc_change_GDP_percap_WEO_lag	inflation_lagged	 	 i.country_id	 if income_status !="High income" 		
eststo reg17b: quietly reg current_spread fiscal_rule_any post_crisis fiscal_rule_post_crisis ger	 		xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lagged	 	 i.country_id	 if income_status !="High income" 
 
esttab  reg12b   reg14b reg15b  reg17b      using ".\Output\Table_A7.rtf", replace r2(4)   starl( * 0.10 ** 0.05 *** 0.010)  drop(_cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(fiscal_rule_any post_crisis fiscal_rule_post_crisis  ger perc_change_GDP_percap_WEO_lag inflation_lagged pby_lagged  xtdebty_lagged  )  indicate("Country Fixed Effects = *.country_id")  compress label ///
title(Table A7. Difference-in-Difference Estimates of Fiscal Rule Impact During GFC) ///
nonumbers
  

 

