use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
tab geography 
sort country date

 
 
keep date country country_id current_spread geography geography_id
**Assumptions: Don't exclude high income from this regional factor, and keep every single region separate
/*
Start With Sub-Saharan Africa, Middle East and North Africa
*/
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep if geography=="Sub-Saharan Africa" | geography=="Middle East and North Africa"
tab country
 local varlist angola	cameroon	cotedivoire	ethiopia	gabon	ghana	kenya	mozambique	namibia	nigeria	senegal	southafrica	zambia egypt	iraq	jordan	lebanon	morocco	oman	tunisia
foreach y of local varlist{ 
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep date country country_id current_spread change_spread geography geography_id
keep if geography=="Sub-Saharan Africa" | geography=="Middle East and North Africa"
drop if country=="`y'"
sort date country
collapse  (mean) avg_current_spread=current_spread avg_change_spread=change_spread  ,by(date)
gen country="`y'"
order date country avg_current_spread avg_change_spread
save LU_regional_factor_`y', replace
}
 

/*
East Asia and Pacific, South Asia
*/
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep if geography=="East Asia and Pacific" | geography=="South Asia"
tab country
 local varlist china	india	indonesia	malaysia	mongolia	pakistan	papuanewguinea	philippines	srilanka	vietnam
foreach y of local varlist{ 
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep date country country_id current_spread change_spread geography geography_id
keep if geography=="East Asia and Pacific" | geography=="South Asia"
drop if country=="`y'"
sort date country
collapse  (mean) avg_current_spread=current_spread avg_change_spread=change_spread  ,by(date)
gen country="`y'"
order date country avg_current_spread avg_change_spread
save LU_regional_factor_`y', replace
}

/*
Europe and Central Asia
*/
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep if geography=="Europe and Central Asia"
tab country
 local varlist armenia	azerbaijan	belarus	croatia	georgia	hungary	kazakhstan	lithuania	poland	romania	russia	serbia	slovakia	tajikistan	turkey	ukraine
foreach y of local varlist{ 
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep date country country_id current_spread change_spread geography geography_id
keep if geography=="Europe and Central Asia"
drop if country=="`y'"
sort date country
collapse  (mean) avg_current_spread=current_spread avg_change_spread=change_spread  ,by(date)
gen country="`y'"
order date country avg_current_spread avg_change_spread
save LU_regional_factor_`y', replace
}

/*
Latin America and the Caribbean
*/
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep if geography=="Latin America and the Caribbean"
tab country
 local varlist argentina	belize	bolivia	brazil	chile	colombia	costarica	dominicanrepublic	ecuador	elsalvador	guatemala	honduras	jamaica	mexico	panama	paraguay	peru	suriname	trinidadamptobago	uruguay	venezuela
foreach y of local varlist{ 
use Spreads_Analysis_Expanded_Empirical_Tests_2_Extend_2022, replace
keep date country country_id current_spread change_spread geography geography_id
keep if geography=="Latin America and the Caribbean"
drop if country=="`y'"
sort date country
collapse  (mean) avg_current_spread=current_spread avg_change_spread=change_spread  ,by(date)
gen country="`y'"
order date country avg_current_spread avg_change_spread
save LU_regional_factor_`y', replace
}

/*
Stack all tables into one big lookup
*/
use LU_regional_factor_angola, replace
 local varlist  argentina	armenia	azerbaijan	belarus	belize	bolivia	brazil	cameroon	chile	china	colombia	costarica	cotedivoire	croatia	dominicanrepublic	ecuador	egypt	elsalvador	ethiopia	gabon	georgia	ghana	guatemala	honduras	hungary	india	indonesia	iraq	jamaica	jordan	kazakhstan	kenya	lebanon	lithuania	malaysia	mexico	mongolia	morocco	mozambique	namibia	nigeria	oman	pakistan	panama	papuanewguinea	paraguay	peru	philippines	poland	romania	russia	senegal	serbia	slovakia	southafrica	srilanka	suriname	tajikistan	trinidadamptobago	tunisia	turkey	ukraine	uruguay	venezuela	vietnam	zambia
foreach y of local varlist{ 
append using LU_regional_factor_`y' 
}
rename avg_current_spread RF_Levels_Fewer_Groups
rename avg_change_spread RF_Changes_Fewer_Groups
save LU_Regional_Factor_Fewer_Groups, replace

