clear

use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
drop if income_status=="High income"
merge m:1 year country using  ".\Files for Reproduction - Fiscal Rule Index\lu_strength_of_rule_final_lag.dta"
sort country date
drop if _merge==2
replace weighted_score_rescaled_lag=0 if weighted_score_rescaled_lag==.
 drop _merge


******************************************************************************************************
**1) Baseline Analysis
******************************************************************************************************
label variable EMBI_global "EMBI Global"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable cembi_ig "CEMBI"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable ger "Government Effectiveness"
label variable xtdebty_lagged "Total External Debt Stocks"
label variable pby_lagged "Primary Balance"
label variable ecbaction "ECB Policy Dummy"
label variable fedaction "Fed Policy Dummy"
label variable change_stringency "Stringency Index"
label variable fiscal_rule_any "Fiscal Rule"
label variable inflation_lag_backfilled "Inflation"
label variable perc_change_GDP_percap_WEO_lag "GDP Per Capita Growth"
label variable weighted_score_rescaled_lag "Fiscal Rule Index (Lagged)"

eststo reg1z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	i.year_month	 i.country_id	 if income_status !="High income" 				
eststo reg2z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg3z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg4z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg5z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" 
 
esttab  reg1z  reg2z reg3z  reg4z reg5z    using ".\Output\Table_2.rtf", replace r2(4)   starl( * 0.10 ** 0.05 *** 0.010)  drop(RF_Levels_Fewer_Groups	cembi_ig ecbaction fedaction  _cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(fiscal_rule_any  EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  fedaction ecbaction change_stringency) indicate( "Global/Regional/Corporate Factors = EMBI_global" "Policy-Related Controls = change_stringency" "Total External Debt Stocks =xtdebty_lagged "  " Primary Balance= pby_lagged" " GDP Per Capita Growth= perc_change_GDP_percap_WEO_lag" "Inflation = inflation_lag_backfilled" "Government Effectiveness = ger" "Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")   compress label ///
title(Table 2. Panel Regression Estimates of Fiscal Rule Impact on Sovereign Spreads) ///
nonumbers


eststo reg1: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	i.year_month	 i.country_id	 if income_status !="High income" 				
eststo reg2: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg3: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg4: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg5: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" 
 
esttab  reg1  reg2 reg3  reg4 reg5    using ".\Output\Table_A4.rtf", replace r2(4)   starl( * 0.10 ** 0.05 *** 0.010)  drop(   _cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(fiscal_rule_any  EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  fedaction ecbaction change_stringency) indicate("Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")   compress label ///
title(Table A4. Panel Regression Estimates of Fiscal Rule Impact on Sovereign Spreads (COVID-19 Timeframe)) ///
nonumbers




**Fiscsal Rule Index (Lagged)
eststo reg1b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	   weighted_score_rescaled_lag ger	i.year_month	 i.country_id	 if income_status !="High income" 				
eststo reg2b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	   weighted_score_rescaled_lag ger	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg3b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	   weighted_score_rescaled_lag ger	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg4b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	   weighted_score_rescaled_lag ger	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg5b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	   weighted_score_rescaled_lag ger	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" 
esttab  reg1b  reg2b reg3b  reg4b reg5b    using ".\Output\Table_A10.rtf", replace r2(4)   starl( * 0.10 ** 0.05 *** 0.010)  drop(   _cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(weighted_score_rescaled_lag EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  fedaction ecbaction change_stringency) indicate("Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")   compress label ///
title(Table A10. Panel Regression Estimates of Fiscal Rule Index and Spreads (COVID-19 Timeframe) ) ///
nonumbers


******************************************************************************************************
**2) Diff-in-Diff looking at pre- and post-covid:
******************************************************************************************************
 drop post_covid
 drop fiscal_rule_post_covid
 gen post_covid=0
 replace post_covid=1 if date>=date("20200301","YMD") 
 
 gen fiscal_rule_post_covid=fiscal_rule_any*post_covid
  gen fiscal_rule_index_post_covid=weighted_score_rescaled_lag*post_covid

  
 label variable fiscal_rule_index_post_covid "Fiscal Rule Index#Post Covid" 
label variable EMBI_global "EMBI Global"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable cembi_ig "CEMBI"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable ger "Government Effectiveness"
label variable xtdebty_lagged "Total External Debt Stocks"
label variable pby_lagged "Primary Balance"
label variable ecbaction "ECB Policy Dummy"
label variable fedaction "Fed Policy Dummy"
label variable change_stringency "Stringency Index"
label variable fiscal_rule_any "Fiscal Rule"
label variable inflation_lag_backfilled "Inflation"
label variable perc_change_GDP_percap_WEO_lag "GDP Per Capita Growth"
label variable post_covid "Post Covid"
label variable fiscal_rule_post_covid "Fiscal Rule#Post Covid"





eststo reg1b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid i.country_id	 if income_status !="High income" 				
eststo reg2b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	xtdebty_lagged	pby_lagged	  i.country_id	 if income_status !="High income" 		
eststo reg3b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.country_id	 if income_status !="High income" 		
eststo reg4b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.country_id	 if income_status !="High income" 
eststo reg5b: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.country_id	 if income_status !="High income" 
esttab  reg1b  reg2b reg3b reg4b reg5b using ".\Output\Table_A6.rtf", replace  r2(4)   starl( * 0.10 ** 0.05 *** 0.010)   drop(   _cons)  mtitles("(1)" "(2)" "(3)" "(4)" "(5)")  order(fiscal_rule_any post_covid fiscal_rule_post_covid EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged xtdebty_lagged  fedaction ecbaction change_stringency)  indicate("Country Fixed Effects = *.country_id")  compress label ///
title(Table A6. Difference-in-Difference Estimates of Fiscal Rule Impact in Post-Covid Time Period) ///
nonumbers



eststo reg1z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid i.country_id	 if income_status !="High income" 				
eststo reg2z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	xtdebty_lagged	pby_lagged	  i.country_id	 if income_status !="High income" 		
eststo reg3z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.country_id	 if income_status !="High income" 		
eststo reg4z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.country_id	 if income_status !="High income" 
eststo reg5z: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any post_covid	 fiscal_rule_post_covid	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.country_id	 if income_status !="High income" 
esttab  reg1z  reg2z reg3z  reg4z reg5z    using ".\Output\Table_3.rtf", replace r2(4)   starl( * 0.10 ** 0.05 *** 0.010)  drop(RF_Levels_Fewer_Groups	cembi_ig ecbaction fedaction  _cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(fiscal_rule_any  EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  fedaction ecbaction change_stringency) indicate( "Global/Regional/Corporate Factors = EMBI_global" "Policy-Related Controls = change_stringency" "Total External Debt Stocks =xtdebty_lagged "  " Primary Balance= pby_lagged" " GDP Per Capita Growth= perc_change_GDP_percap_WEO_lag" "Inflation = inflation_lag_backfilled" "Government Effectiveness = ger" "Country Fixed Effects = *.country_id" )   compress label ///
title(Table 3. Difference-in-Difference Estimates of Fiscal Rule Impact in Post-Covid Period) ///
nonumbers



*Fiscal Rule Index
eststo reg1c: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	weighted_score_rescaled_lag post_covid	 fiscal_rule_index_post_covid i.country_id	 if income_status !="High income" 				
eststo reg2c: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	weighted_score_rescaled_lag post_covid	 fiscal_rule_index_post_covid	xtdebty_lagged	pby_lagged	  i.country_id	 if income_status !="High income" 		
eststo reg3c: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	weighted_score_rescaled_lag post_covid	 fiscal_rule_index_post_covid	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.country_id	 if income_status !="High income" 		
eststo reg4c: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	weighted_score_rescaled_lag post_covid	 fiscal_rule_index_post_covid	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.country_id	 if income_status !="High income" 
eststo reg5c: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	weighted_score_rescaled_lag post_covid	 fiscal_rule_index_post_covid	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.country_id	 if income_status !="High income" 

esttab  reg1c  reg2c reg3c reg4c reg5c using ".\Output\Table_A11.rtf", replace  r2(4)   starl( * 0.10 ** 0.05 *** 0.010)   drop(   _cons)  mtitles("(1)" "(2)" "(3)" "(4)" "(5)")  order(weighted_score_rescaled_lag post_covid fiscal_rule_index_post_covid EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged xtdebty_lagged  fedaction ecbaction change_stringency)  indicate("Country Fixed Effects = *.country_id")  compress label ///
title(Table A11. Difference-in-Difference Estimates of Fiscal Rule Index and Spreads in Post-Covid Time Period) ///
nonumbers
 
 
 
******************************************************************************************************
**3) Weekly Interactions
****************************************************************************************************** 
 gen week_numeric=week(date)
 tostring week_numeric, gen(week)
 drop week_numeric
  tostring year, gen(year_string)
 gen year_week=year_string+week
 order year_week
 rename year_week year_week_string
 drop if date==.
 destring year_week_string, gen(year_week)
   set matsize 5000
  
eststo regmonthly: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_any##i.year_week	 i.country_id	 if income_status !="High income" 	
estimates store weekly
outreg2 using ".\Output\regweekly.xls", replace excel drop(EMBI_global  RF_Levels_Fewer_Groups cembi_ig ger)  noaster noparen 
 
 
******************************************************************************************************
**4) Baseline Analysis, Compare Suspensions With Activations of Escape Clause
******************************************************************************************************
clear
use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
keep year country  fiscal_rule_no_suspension escapeclause suspension
bysort year country  fiscal_rule_no_suspension escapeclause suspension: keep if _n==1 
drop if year==.
replace year=year+1
rename fiscal_rule_no_suspension fiscal_rule_no_suspension_lag
rename escapeclause escapeclause_lag
rename suspension suspension_lag
drop if year==2023
save ".\Files for Reproduction - Covid Spreads\lagged_suspensions_20_22.dta" , replace

use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
keep year country  lagged_fiscal_rule_any escapeclause suspension
order  country   year escapeclause suspension lagged_fiscal_rule_any
bysort year country  lagged_fiscal_rule_any escapeclause suspension: keep if _n==1 
keep if year==2019
replace escapeclause=0
replace suspension=0
rename lagged_fiscal_rule_any fiscal_rule_no_suspension_lag
rename escapeclause escapeclause_lag
rename suspension suspension_lag
append using ".\Files for Reproduction - Covid Spreads\lagged_suspensions_20_22.dta" 
save ".\Files for Reproduction - Covid Spreads\lagged_suspensions_19_22.dta" , replace



use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
drop if income_status=="High income"
merge m:1 year country using  ".\Files for Reproduction - Fiscal Rule Index\lu_strength_of_rule_final_lag.dta"
sort country date
drop if _merge==2
replace weighted_score_rescaled_lag=0 if weighted_score_rescaled_lag==.
 drop _merge
drop if date==.
merge m:1 year country using ".\Files for Reproduction - Covid Spreads\lagged_suspensions_19_22.dta"
drop if _merge==2
 drop _merge

gen fiscal_rule_category=0
replace fiscal_rule_category=2 if fiscal_rule_any==1
replace fiscal_rule_category=1 if escapeclauseorsuspension==1
drop if country=="Russia"
replace  escapeclause=0 if suspension==1 & escapeclause==1
replace  escapeclause_lag=0 if suspension_lag==1 & escapeclause_lag==1 
gen  fiscal_rule_no_susp_index=fiscal_rule_no_suspension*weighted_score_rescaled
gen  escapeclause_index=escapeclause*weighted_score_rescaled
gen  suspension_index=suspension*weighted_score_rescaled
gen  fiscal_rule_no_susp_index_lag=fiscal_rule_no_suspension*weighted_score_rescaled_lag
gen  escapeclause_index_lag=escapeclause*weighted_score_rescaled_lag
gen  suspension_index_lag=suspension*weighted_score_rescaled_lag


label variable fiscal_rule_no_suspension "Fiscal Rule - No Suspension or Escape Clause"
label variable escapeclause "Escape Clause"
label variable suspension "Suspension"
label variable fiscal_rule_no_suspension_lag "Fiscal Rule - No Suspension or Escape Clause (Lag)"
label variable escapeclause_lag "Escape Clause (Lag)"
label variable suspension_lag "Suspension (Lag)"
label variable EMBI_global "EMBI Global"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable cembi_ig "CEMBI"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable ger "Government Effectiveness"
label variable xtdebty_lagged "Total External Debt Stocks"
label variable pby_lagged "Primary Balance"
label variable ecbaction "ECB Policy Dummy"
label variable fedaction "Fed Policy Dummy"
label variable change_stringency "Stringency Index"
label variable fiscal_rule_any "Fiscal Rule"
label variable inflation_lag_backfilled "Inflation"
label variable perc_change_GDP_percap_WEO_lag "GDP Per Capita Growth"

 
*Everything in Levels (No Russia, Categorize Russia and Paraguay as Suspending)
eststo reg1d: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	i.year_month	 i.country_id	 if income_status !="High income" 				
eststo reg2d: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg3d: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg4d: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg5d: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" 

esttab  reg1d  reg2d reg3d  reg4d reg5d    using ".\Output\Table_A8.rtf", replace  r2(4)   starl( * 0.10 ** 0.05 *** 0.010)    drop(_cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)")  order(fiscal_rule_no_suspension escapeclause  suspension   EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  xtdebty_lagged fedaction ecbaction change_stringency)  indicate("Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")   compress label ///
title(Table A8. Panel Regression Estimates of Escape Clause vs. Suspension Usage on Sovereign Spreads) ///
nonumbers

eststo reg1dz: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	i.year_month	 i.country_id	 if income_status !="High income" 				
eststo reg2dz: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg3dz: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg4dz: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg5dz: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" 

esttab  reg1dz  reg2dz reg3dz  reg4dz reg5dz    using ".\Output\Table_4.rtf", replace  r2(4)   starl( * 0.10 ** 0.05 *** 0.010)    drop(RF_Levels_Fewer_Groups	cembi_ig ecbaction fedaction  _cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(  EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  fedaction ecbaction change_stringency) indicate( "Global/Regional/Corporate Factors = EMBI_global" "Policy-Related Controls = change_stringency" "Total External Debt Stocks =xtdebty_lagged "  " Primary Balance= pby_lagged" " GDP Per Capita Growth= perc_change_GDP_percap_WEO_lag" "Inflation = inflation_lag_backfilled" "Government Effectiveness = ger" "Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")   compress label ///
title(Table 4. Panel Regression Estimates of Escape Clause vs. Suspension Usage on Sovereign Spreads) ///
nonumbers


**Using Lagged Fiscal Rule Index:
eststo reg1e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_susp_index_lag escapeclause_index_lag suspension_index_lag	i.year_month	 i.country_id	 if income_status !="High income" 			
eststo reg2e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_susp_index_lag escapeclause_index_lag suspension_index_lag	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg3e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_susp_index_lag escapeclause_index_lag suspension_index_lag	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg4e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_susp_index_lag escapeclause_index_lag suspension_index_lag	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg5e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_susp_index_lag escapeclause_index_lag suspension_index_lag	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" 

esttab  reg1e  reg2e reg3e  reg4e reg5e    using ".\Output\Table_A12.rtf", replace  r2(4)   starl( * 0.10 ** 0.05 *** 0.010)    drop(_cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)")  order( fiscal_rule_no_susp_index_lag escapeclause_index_lag suspension_index_lag    EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  xtdebty_lagged fedaction ecbaction change_stringency)  indicate("Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")   compress label ///
title(Table A12. Panel Regression Estimates of Escape Clause vs. Suspension Usage on Spreads, Using Lag of Fiscal Rule Index) ///
nonumbers
 

 
******************************************************************************************************
**5) Baseline Analysis, Compare Suspensions With Activations of Escape Clause (Alternative Assumption)
******************************************************************************************************
use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace

gen fiscal_rule_category=0
replace fiscal_rule_category=2 if fiscal_rule_any==1
replace fiscal_rule_category=1 if escapeclauseorsuspension==1
 
drop if country=="Russia"
replace  suspension=0 if suspension==1 & escapeclause==1

label variable fiscal_rule_no_suspension "Fiscal Rule - No Suspension or Escape Clause"
label variable escapeclause "Escape Clause"
label variable suspension "Suspension"
label variable EMBI_global "EMBI Global"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable cembi_ig "CEMBI"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable ger "Government Effectiveness"
label variable xtdebty_lagged "Total External Debt Stocks"
label variable pby_lagged "Primary Balance"
label variable ecbaction "ECB Policy Dummy"
label variable fedaction "Fed Policy Dummy"
label variable change_stringency "Stringency Index"
label variable fiscal_rule_any "Fiscal Rule"
label variable inflation_lag_backfilled "Inflation"
label variable perc_change_GDP_percap_WEO_lag "GDP Per Capita Growth"

 
*Everything in Levels (No Russia, Categorize Russia and Paraguay as Suspending)
eststo reg1e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	i.year_month	 i.country_id	 if income_status !="High income" 				
eststo reg2e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg3e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 		
eststo reg4e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 
eststo reg5e: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig ger	fiscal_rule_no_suspension escapeclause suspension	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" 

esttab  reg1e  reg2e reg3e  reg4e reg5e    using ".\Output\Table_A9.rtf", replace  r2(4)   starl( * 0.10 ** 0.05 *** 0.010)    drop(_cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)")  order(fiscal_rule_no_suspension escapeclause  suspension   EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  xtdebty_lagged fedaction ecbaction change_stringency)   indicate("Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")  compress label ///
title(Table A9. Panel Regression Estimates of Escape Clause vs. Suspension Usage on Sovereign Spreads) ///
nonumbers

******************************************************************************************************
**Outlier Tests
******************************************************************************************************
 local varlist 2019 2020 2021 2022 
foreach x of local varlist  {
clear
use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
drop if income_status=="High income"
drop if current_spread==.
keep if year==`x'
collapse (mean) country_mean_spread=current_spread  , by(  country)
gen group=1
collapse (mean) mean_spread=country_mean_spread (sd) std_spread=country_mean_spread, by(  group)
save ".\Files for Reproduction - Covid Spreads\overall_avg_sd_`x'.dta" , replace
}


local varlist2 2019 2020 2021 2022 
foreach y of local varlist2  {
 clear
use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
drop if income_status=="High income"
drop if current_spread==.
keep if year==`y'
collapse (mean) current_spread=current_spread, by(  country)
gen year=1
gen spread_rank=-1*current_spread
sort year spread_rank
bysort year: gen rank=_n
drop spread_rank
rename year group
merge m:1 group using ".\Files for Reproduction - Covid Spreads\overall_avg_sd_`y'"
drop _merge
keep if (current_spread>mean_spread+3*std_spread) |  (current_spread<mean_spread-3*std_spread)
keep country
save ".\Files for Reproduction - Covid Spreads\outliers_`y'.dta" , replace
}

use ".\Files for Reproduction - Covid Spreads\outliers_2019.dta", replace
local varlist3   2020 2021 2022 
foreach z of local varlist3  {
append using ".\Files for Reproduction - Covid Spreads\outliers_`z'.dta"
}
bysort country: keep if _n==1
rename country outliers
**Lebanon and Venezuela are outlier countries


use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
drop if income_status=="High income"
label variable EMBI_global "EMBI Global"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable cembi_ig "CEMBI"
label variable RF_Levels_Fewer_Groups "Regional Factor"
label variable ger "Government Effectiveness"
label variable xtdebty_lagged "Total External Debt Stocks"
label variable pby_lagged "Primary Balance"
label variable ecbaction "ECB Policy Dummy"
label variable fedaction "Fed Policy Dummy"
label variable change_stringency "Stringency Index"
label variable fiscal_rule_any "Fiscal Rule"
label variable inflation_lag_backfilled "Inflation"
label variable perc_change_GDP_percap_WEO_lag "GDP Per Capita Growth"
 
**Original Tests with outliers removed
eststo reg1: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger  	i.year_month	 i.country_id	 if income_status !="High income" & country!="venezuela" & country!="lebanon" 				
eststo reg2: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger  	xtdebty_lagged	pby_lagged	i.year_month	 i.country_id	 if income_status !="High income" 	& country!="venezuela" & country!="lebanon" 		
eststo reg3: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger  	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" 	& country!="venezuela" & country!="lebanon" 		
eststo reg4: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger  	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled	i.year_month	 i.country_id	 if income_status !="High income" & country!="venezuela" & country!="lebanon" 	
eststo reg5: quietly reg current_spread	EMBI_global	RF_Levels_Fewer_Groups	cembi_ig	fiscal_rule_any ger  	xtdebty_lagged	pby_lagged	perc_change_GDP_percap_WEO_lag	inflation_lag_backfilled   change_stringency ecbaction fedaction i.year_month	 i.country_id	 if income_status !="High income" & country!="venezuela" & country!="lebanon" 	
 
esttab  reg1  reg2 reg3  reg4 reg5    using ".\Output\Table_A13.rtf", replace r2(4)   starl( * 0.10 ** 0.05 *** 0.010)  drop(   _cons) mtitles("(1)" "(2)" "(3)" "(4)" "(5)") order(fiscal_rule_any  EMBI_global cembi_ig  RF_Levels_Fewer_Groups ger perc_change_GDP_percap_WEO_lag inflation_lag_backfilled pby_lagged  fedaction ecbaction change_stringency) indicate("Country Fixed Effects = *.country_id" "Month Fixed Effects = *.year_month")   compress label ///
title(Table A13. Panel Regression Estimates of Fiscal Rule Impact on Sovereign Spreads (COVID-19 Timeframe)) ///
nonumbers
 
