/*
Data Analysis for Time Trends Showing Avg Daily Spread for EMDEs
Scott Sommers
2/24/23
*/

 

************************************************************************************************************************************
**Fiscal Rule vs. No Fiscal Rule
************************************************************************************************************************************

  *1) EMDEs (Exclude High Income Grouping) - P50, Separate Fiscal Rule vs No Rule
use ".\Files for Reproduction - Covid Spreads\Spreads_Analysis_Expanded_Empirical_Tests_Final_Thru_2022_Jan_23.dta", replace
keep date country country_id current_spread geography geography_id income_status fiscal_rule_any
drop if income_status=="High income"
gen spread= exp(current_spread)

collapse  (p50) p50_spread_all_emde_low_income=spread  (p33) p25_spread_all_emde_low_income=spread (p66) p75_spread_all_emde_low_income=spread,by(date fiscal_rule_any)
reshape wide p50_spread_all_emde_low_income p25_spread_all_emde_low_income p75_spread_all_emde_low_income, i(date) j(fiscal_rule_any)  

export delimited using ".\Output\Figure 3 Chart Input.csv",   replace

 